CGROUP  GROUP   CODE_SEG
        ASSUME  CS:CGROUP, DS:CGROUP

;-------------------------------------------------------------
CODE_SEG        SEGMENT PUBLIC
.386

inizio    EQU 64000-1-320*14
SPRITES   EQU 8
XSPRITES  EQU SPRITES*2

org 100h

;-------------------------------------------------------------
INFERNO proc near
        push 0a000h
        pop es
        mov bp,640       ; fossato
;-------------------------------------------------------------
loopschermo:
        mov ax,13h      ; 320x200 256 colori
        int 10h         ; imposta modo video

        mov dh, 3fh
        mov ax, 1010h
        mov bl, 0ffh
        xor cx, cx
ciclo_dac:
        int 10h
        mov ch,bl
        shr ch,2
        dec bl
        jne ciclo_dac

        xor ax,ax
        int 33h               ; abilita mouse
;--------------------------------------------------------
ciclo1:
        xor cx,cx
ciclo_punti:
;------------------------------------incrementa punteggio (+cl)
        mov di,8               ; numero caratteri
        mov dx,180ch           ; linea e colonna per i punti
        mov bx,di              ; colore per il punteggio
scrivi:
        mov al,punti[di]
        add al,cl
        setc cl
        cmp al,'A'
        jnc ok9
        cmp al,'9'+1
        jl ok9
        inc cx
        sub al,10
ok9:
        mov punti[di],al

        mov ah,2
        int 10h              ; cursore a linea 24 colonna dl
        dec dl

        mov ah,0eh
        int 10h
        
        dec di
        jns scrivi
;-------------------------------------------------------------
        mov ax,3              ; legge il mouse
        int 33h               ; cx=X dx=Y

        and bl,al
        jne finito

        mov ax,dx             ; Y*320
        shl ax,2

        add dx,ax
        shr cx,1
        shl dx,6
        add dx,cx             ; +X dx=mouse : punta al byte in memoria video

;--------------------------------------------------------
; riga inferiore
;--------------------------------------------------------

        mov di,inizio
        mov si,di
        mov cx,bp
        add si,cx
        in al,40h       ; legge timer
random:
        add al,45
        stosb
        loop random

;-----------------------------------------------------------
ciclo3:
        xor ax,ax
ciclo2:
;-----------------------------------------------
        cmp si,dx
        je non_presa_fiammella     ; visualizza mouse

        mov bx,XSPRITES
;------------------------------------
ciclo_fiammelle:
        dec bx 
        dec bx
        js sfondo
;------------------------------------
fiammelle:
        xor cx,cx
        mov di,posizioni[bx]
        cmp di,inizio
        jnc ricarica

        mov cx,di
        sub cx,si
        cmp cx,16
        ja short ciclo_fiammelle
        jne non_spostare_fiammella
        add posizioni[bx],bp        
non_spostare_fiammella:
        mov cx,di
        sub cx,dx ; posizione mouse
        cmp cx,16
        ja short non_presa_fiammella
presa_fiammella:
        mov cl,5
        stc
ricarica:
        adc punti,0ffh

        in al,61h
        xor al,10b
        out 61h,al

        add posizioni[bx],inizio/2 ; posizione casuale
        jmp ciclo_punti
;------------------------------------
non_presa_fiammella:
        mov es:[si], bh ;byte ptr 0h
;------------------------------------
sfondo:
        mov bl,es:[si]
        add ax,bx
        mov bl,es:[si+4]
        sub ax,bx

        mov bx,ax
        shr bx,2

        mov cl,punti         ; schermo
        sub cl,'0'

        xor bl, cl
        mov es:[si-318], bl

        dec si
        je ciclo1
        jne ciclo2
;-------------------------------------------------------------
finito:
        xor ah,ah
        int 16h         ; attende tasto

        mov ax,03h      ; video default
        int 10h         ; imposta modo video
        ret             ; equivale a int 20h
;-------------------------------------------------------------
punti     DB "9HELL0000"
posizioni LABEL WORD ;DW 0,60,120,180,200

;-------------------------------------------------------------

INFERNO endp


CODE_SEG        ENDS
;-------------------------------------------------------------
end INFERNO
